//---------------------------------------------------------------------------
// String object rewrite v1.5
//	Branden J. Hall
//	Fig Leaf Software
//
//	Thanks to Damien Morton for the indexOf code
//	Thanks to Steven Yi for the *great* idea for the split code
//	Thanks to Dave@opaque.net for an additional speed boost to split
//	Thanks to Jobe Makar for spotting a bug in split
//---------------------------------------------------------------------------
String.prototype.charAt = function(index){
	return(substring(this, index+1, 1));
}

String.prototype.concat = function(){
	var r = this.toString();
	for (var i=0; i<arguments.length; ++i){
		r += arguments[i];
	}
	return (r);
}

String.prototype.indexOf = function(sub, i){
	if (i == null) i = 0;
	var size = sub.length;
	var last = this.length - size + 1;
	while ((i <= last) && (substring(this, 1+i++, size) != sub));
	return (i <= last ? (i-1) : -1);
}

String.prototype.lastIndexOf = function(sub, i){
	size = sub.length;
	i == null ? i = this.length - size + 1 : ++i;
	if (sub.length == 0) return i-1;
	while ((i >= 0) && (substring(this, i--, size) != sub));
	return (i == -1 ? -1 : (i));
}

String.prototype.slice = function(s, e){
	return(substring(this, s+1, e-s));
}

String.prototype.split = function(d){
	if (d != null){
		var r = new Array();
		var size = this.length;
		var c = 0;
		var n = 0;
		if (d != ""){
			for (var i=0; i<=size; ++i){
				if (substring(this, i+1, 1) == d){
					r[n] = substring(this, c+1, i-c);
					c = i+1;
					++n;
				}
			}
			if (c != i){
				r[n] = substring(this, c+1, i-c);
			}
		}else{
			for (var i=0; i<s; ++i){
					r[i] = substring(this, i+1, 1);
			}	
		}
	}else{
		r = new Array(this.toString());
	}
	return (r);
}

String.prototype.substr = function(s, l){
	if (l == null){
		l = this.length - s;
	}
	return(substring(this, s+1, l));
}

//---------------------------------------------------------------------------

/*
* String Library version .98 created by Mike Chambers
* mesh@speakeasy.org
* http://www.markme.com/as/flashsql/
*
* This library is a set of useful string functions that are not included with the
* built in Flash 5 Action Script String object.
*
* It is strongly suggested that you use these in conjunction with the
* optimized String object created by Branden Hall. You can download the
* optimized String object from:
*
* http://chattyfig.figleaf.com/~bhall/code/string.as
*
* Thanks to:
* Branden Hall
* Ben Glazer
*/


/**
* This methods trims all of the white space from the left side of a String.
*/
String.prototype.ltrim = function()
{

	var size = this.length;
	for(i = 0; i < size; i++)
	{
		if(this.charCodeAt(i) > 32)
		{
			return this.substring(i);
		}
	}
	return "";

}

/**
* This methods trims all of the white space from the right side of a String.
*/
String.prototype.rtrim = function()
{
	var size = this.length;
	for(i = size; i > 0; i--)
	{
		if(this.charCodeAt(i) > 32)
		{
			return substring(this, 0, i + 1);
		}
	}
	return "";
}

/**
* This methods trims all of the white space from both sides of a String.
*/
String.prototype.trim = function()
{
	return this.rtrim().ltrim();
}

/**
* This methods returns true if the String ends with the string passed into
* the method. Otherwise, it returns false.
*/
String.prototype.endsWith = function(s)
{
	return(substring(this, this.length - s.length + 1) == s);
}

/**
* This methods returns true if the String begins with the string passed into
* the method. Otherwise, it returns false.
*/
String.prototype.beginsWith = function(s)
{
	return(s == substring(this, 1, s.length));
}

//---------------------------------------------------------------------------

// LE CODE NOUVEAU EN LUI MEME...

//---------------------------------------------------------------------------

/*
* Depuis le code de :
* Flash 5 ActionScript SQL Object version .98 created by Mike Chambers
* mesh@speakeasy.org
* http://www.markme.com/as/flashsql/
*/

/*
* Modifi le 7-01-2002 : simplification du transfere de donnes
* Objet Message -> envoie et recupre un tableau de donnes
*/


Message.prototype.onData = function(doc){
	this.active = false;
	doc=doc.trim();
	delete(this.result);
	this.result=doc.split(this.rowDelimiter);
	this.length1=this.result.length;
	for(this.i=0; this.i<this.length1; this.i++){
		this.result[this.i] = this.result[this.i].split(this.columnDelimiter);
	}
	this.MessageOnData(this.result,this.sender);
//trace('------------');
//trace(doc);
//trace('------------');
}

Message.prototype.execute = function(query){
	this.active = true;
	this.load(this.serverUrl+"?"+this.queryVariableName+"="+escape(query)+"&columnDelimiter="+escape(this.columnDelimiter)+"&rowDelimiter="+escape(this.rowDelimiter));
}

Message.prototype.sendArray = function(anArray,lesender){
     if(!this.active){
	 this.sender=lesender;
	 this.str='';
	 this.length1=anArray.length;
	 for(this.i=0; this.i<this.length1; this.i++){
			this.length2=anArray[this.i].length-1;
			for(this.j=0; this.j<this.length2; this.j++){
				this.str+=anArray[this.i][this.j]+this.columnDelimiter;
			}
			this.str+=anArray[this.i][this.j]+this.rowDelimiter;
	 }
	 this.execute(this.str);
	 return true;
      }else{
	 return false;
      }
}


Message.prototype.setServerUrl = function(url){
	this.serverUrl = url;
}

Message.prototype.isActive = function(){
	return this.active;
}

Message.prototype.setColumnDelimiter = function(del){
	this.columnDelimiter = del;
}

Message.prototype.setRowDelimiter = function(del){
	this.rowDelimiter = del;
}

Message.prototype.setQueryVariableName = function(qName){
	this.queryVariableName = qName;
}

function Message(){
	this.queryVariableName = "query";
	this.columnDelimiter = chr(2);
	this.rowDelimiter = chr(3);
	this.active = false;
	this.serverUrl = "reponse.php3";
	this.liste=new Array();
}

Message.prototype.__proto__ = XML.prototype;
Message.prototype.superClass = XML.prototype.constructor;

